setInfos(6, "BattleshipShock", "A game with estim shocks","NIFOC99", "v0.5", 0xA9DFBF,
	"en", ["game", "formale", "forfemale", "internet"])
// v0.3 first version
// v0.4 and v0.5 corrected file Explosion.png->explosion.png

def B = "BattleshipShock"
def Title = "<h1>"+B+"</h1>"

def Version = "v0.5"

setImage(null)
show(Title+"Setting up...")

def Connected = loadBoolean(B+".Connected")?:true
if(!isConnected()){Connected = false}
save(B+".Connected", Connected)
if(Connected){
	if(receiveString(B+".Version")!=Version) { //check for latest version
		show(Title+"This is not the latest version.\n\n"+
		"Check for the latest version at ss.deviatenow.com/scripts.php")
		showButton("OK")
	}
}
def ShowPics = loadBoolean(B+".ShowPics")?:true
def TakePics = loadBoolean(B+".TakePics")?:true

def ASize = 7
def xString = "ABCDEFG"
def yString = "1234567"
def ShipType = ["", "destroyer", "cruiser", "battleship", "aircraft carrier"]
def ShipSize = [0, 2, 3, 4, 5]
def ShipPicture = ["blank", "D", "C", "B", "A"]
def nTries = loadInteger(B+".nTries")?:10000
def maxTime = loadInteger(B+".maxTime")?:100

def MyShips = [[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0]]
def EnemyShips = [[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0]]
def MyShots = [[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0]]
def EnemyShots = [[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0],
	[0, 0, 0, 0, 0, 0, 0]]
def lastHit = false
def lastHitx = 0
def lastHity = 0
def MyScore = 0
def MyScores = [0, 2, 3, 4, 5]
def EnemyScore = 0
def EnemyScores = [0, 2, 3, 4, 5]

show(Title+"Setting up...")

def EnemyPictures = []
if(ShowPics){
	for(def i=0; i<15; i++){
		def p = ""
		if(Connected)p = receiveString(B+".picture"+i)
		if(p==""||p==null)EnemyPictures<<B+"/EnemyPicture"+i+".jpg"
		else EnemyPictures<<receiveImage(p)
	}
}

//Closures (functions)########################################################################################

def picBlank = {def pic -> //checks if picture is blank (all the same colour)---------------------------------

	if (getDataFolder().toLowerCase().contains("android")) {return false} //don't try with android

	def image = javax.imageio.ImageIO.read(new File(pic))
	int width = image.getWidth()
	int height = image.getHeight()
	if(width<90||height<90) {return true} //might as well be blank

	def a = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def r = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def g = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def b = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def asum = 0; def rsum = 0; def gsum = 0; def bsum = 0

	for (def k = 0; k < 10; k++) {
		int x = getRandom(width)
		int y = getRandom(height)
		int p = image.getRGB(x, y)
		a[k] = (p>>24) & 0xff; r[k] = (p>>16) & 0xff; g[k] = (p>>8) & 0xff; b[k] = p & 0xff
		asum = asum+a[k]; rsum = rsum+r[k]; gsum = gsum+g[k]; bsum = bsum+b[k]		
	}
	def aave = asum/10; def rave = rsum/10; def gave = gsum/10; def bave = bsum/10
	def astd = 0; def rstd = 0; def gstd = 0; def bstd = 0

	for (def k = 0; k < 10; k++) {
		astd = astd+(a[k]-aave)*(a[k]-aave)
		rstd = rstd+(r[k]-rave)*(r[k]-rave)
		gstd = gstd+(g[k]-gave)*(g[k]-gave)
		bstd = bstd+(b[k]-bave)*(b[k]-bave)
	}
	astd = Math.sqrt(astd); rstd = Math.sqrt(rstd); gstd = Math.sqrt(gstd); bstd = Math.sqrt(bstd)

	if(astd<50&&rstd<50&&gstd<50&&bstd<50) {return true}
	else {return false}
}

def getPicture = { // Get & validate a picture----------------------------------------------------------------
	def picok = false
	def snapfile = null
	def j = 5 //max tries for picture
	
	show("Get ready for your picture.")
	showButton("Ready")

// Take a picture and get player confirmation
	while (!picok&&j>0) {
// Show a countdown
		for(def k = 3; k > 0; k--) {
			show("..."+k+"...")
			wait(1)
		}
		show("<b>click</b>")

		snapfile = getImage("Capturing Image")
		show(null)
		j--
		if((snapfile==null)||(!snapfile.contains("captured"))||
			picBlank(snapfile)||
			(new Date().getTime())-(new File(snapfile).lastModified())>30*60*1000){
// Try to catch pretending to have webcam by uploading file
			if(!getBoolean("Cheat! That doesn't look like a valid picture taken today!\n\nYou can try again "+
				j+" times. Do you want to? Will you behave?")) {return null}
		}
		else {
			setImage(snapfile)
			show(null)
			if(j>0) {picok = getBoolean("Is that picture OK?\n\n(You can try again "+j+" times)", 
				"Yes", "No")}
			else {picok = getBoolean("Is that picture OK?\n\n(You can't try again)", "Yes", 
				"Give up")}
		}
	}

	if (picok) {return snapfile}
	else {return null}
}

def ShowGrids = {//--------------------------------------------------------------
	def thisImage
	def width = 620
	def height = 339
	def cSize = 36
	def image = new java.awt.image.BufferedImage(width, height, 
		java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	thisImage = javax.imageio.ImageIO.read(new File("images/"+B+"/Grids.png"))
	graphics.drawImage(thisImage, 0, 0, null)
	for(def i=0; i<ASize; i++){
		for(def j=0; j<ASize; j++){
			if(EnemyShots[i][j]!=0){
				thisImage= javax.imageio.ImageIO.read(new File("images/"+B+
					"/explosion.png"))
				graphics.drawImage(thisImage, (37+i*cSize) as int, 
					(81+j*cSize) as int, null)
			}
		}
	}
	for(def i=0; i<ASize; i++){
		for(def j=0; j<ASize; j++){
			if(MyShips[i][j]!=0){
				thisImage= javax.imageio.ImageIO.read(new File("images/"+B+"/"+
					ShipPicture[MyShips[i][j]]+".png"))
				graphics.drawImage(thisImage, (37+i*cSize) as int, 
					(81+j*cSize) as int, null)
			}
		}
	}
	for(def i=0; i<ASize; i++){
		for(def j=0; j<ASize; j++){
			if(MyShots[i][j]!=0){
				thisImage= javax.imageio.ImageIO.read(new File("images/"+B+"/"+
					"explosion.png"))
				graphics.drawImage(thisImage, (360+i*cSize) as int, 
					(81+j*cSize) as int, null)
			}
		}
	}
	for(def i=0; i<ASize; i++){
		for(def j=0; j<ASize; j++){
			if(EnemyShips[i][j]!=0&&MyShots[i][j]!=0){
				if(MyScores[EnemyShips[i][j]]==0){
					thisImage= javax.imageio.ImageIO.read(new File("images/"+B+
						"/"+ShipPicture[EnemyShips[i][j]]+".png"))
				}else{
					thisImage= javax.imageio.ImageIO.read(new File("images/"+B+
						"/X.png"))
				}
				graphics.drawImage(thisImage, (360+i*cSize) as int, 
					(81+j*cSize) as int, null)
			}
		}
	}
	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(image, "png", baos)
	setImage(baos.toByteArray(),0)
}

def SelectShip = {n->//----------------------------------------------------------
	def x = [0, 0, 0, 0, 0]
	def y = [0, 0, 0, 0, 0]
	def e = true
	while(e){
		show(Title+"Place your "+ShipType[n])
		showButton("OK")
		for(def i=0; i<ShipSize[n]; i++){
			def c = getString(Title+"Coordinates (A1 to G7):", "")
			if(c.length()==2){
				x[i] = xString.indexOf(c[0].toUpperCase())
				y[i] = yString.indexOf(c[1])
			}else{
				x[i] = -1
				y[i] = -1
			}
			while(c.length()!=2||x[i]<0||y[i]<0||MyShips[x[i]][y[i]]!=0){
				c = getString(Title+"Try again (A1 to G7):", "")
				if(c.length()==2){
					x[i] = xString.indexOf(c[0].toUpperCase())
					y[i] = yString.indexOf(c[1])
				}else{
					x[i] = -1
					y[i] = -1
				}
			}
			MyShips[x[i]][y[i]] = n
			ShowGrids()
		}
		def xMax = 0
		def xMin = 8
		def xSum = 0
		def yMax = 0
		def yMin = 8
		def ySum = 0
		def facts = [1, 3, 6, 10]
		for(def i=0; i<ShipSize[n]; i++){
			if(x[i]+1>xMax)xMax = x[i]+1
			if(x[i]+1<xMin)xMin = x[i]+1
			xSum = xSum+x[i]+1
			if(y[i]+1>yMax)yMax = y[i]+1
			if(y[i]+1<yMin)yMin = y[i]+1
			ySum = ySum+y[i]+1
		}
		if((Math.abs(xMax-xMin)<0.01&&Math.abs(xSum/ShipSize[n]-xMax)<0.01&&
			Math.abs(yMax-(yMin-1)-ShipSize[n])<0.01)||
			(Math.abs(yMax-yMin)<0.01&&Math.abs(ySum/ShipSize[n]-yMax)<0.01&&
			Math.abs(xMax-(xMin-1)-ShipSize[n])<0.01)){
			e = false
		}else{
			for(def i=0; i<ShipSize[n]; i++){
				MyShips[x[i]][y[i]]=0
			}
			ShowGrids()
			show(Title+"That's not right, try again. Your "+ShipType[n]+
				" should occupy "+ShipSize[n]+" adjacent squares and must "+
				"not be diagonal")
			showButton("OK")
		}
	}
}

def GetEnemyShips = {//----------------------------------------------------------
	def TestGrid = []
	def x0; def y0; def x1; def y1; def direction
	def f = true
	while(f){
		TestGrid = [[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0]]
		f = false
		for(def j=5; j>1; j--){
			def e = true
			while(e){
				x0 = getRandom(ASize)
				y0 = getRandom(ASize)
				direction = getRandom(2)//0 horizontal, 1 vertical
				e = false
				for(def k=0; k<j; k++){
					if(direction==0){
						x1 = x0+k
						y1 = y0
					}else{
						x1 = x0
						y1 = y0+k
					}
					if(x1>=ASize||y1>=ASize){e = true}
					else if(TestGrid[x1][y1]!=0){e = true}
				}
			}
			for(def k=0; k<j; k++){
				if(direction==0){
					TestGrid[x0+k][y0] = j-1
				}else{
					TestGrid[x0][y0+k] = j-1
				}
			}
		}
	}
	for(def j=0; j<ASize; j++){//add hits
		for(def k=0; k<ASize; k++){
			EnemyShips[j][k] = TestGrid[j][k]
		}
	}
}

def GetEnemyShot = {//-----------------------------------------------------------
	def ThinkString = Title+"Thinking"
	def nThink = 0
	def TotalGrid = [[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0],
		[0, 0, 0, 0, 0, 0, 0]]
	def x0; def y0; def x1; def y1; def direction
	def TestGrid = []
	def t0 = new Date().getTime()
	def t = nTries
	for(def i=0; i<t; i++){
		if(i==0||nThink>Math.round(t/10)){
			show(ThinkString)
			ThinkString = ThinkString+"."
			nThink = 0
			if((new Date().getTime())-t0>maxTime/10*1.15*1000&&t>1000){
				t = Math.round(t/1.1)
			}
			t0 = new Date().getTime()
		}
		nThink++
		def f = true
		while(f){
			TestGrid = [[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0],
				[0, 0, 0, 0, 0, 0, 0]]
			f = false
			for(def j=5; j>1; j--){
				if(MyScores[j-1]==0){//add sunk ships
					for(def k=0; k<ASize; k++){
						for(def l=0; l<ASize; l++){
							if(MyShips[k][l]==j-1){TestGrid[k][l] = 1}
						}
					}
				}
			}
			for(def j=5; j>1; j--){
				if(MyScores[j-1]>0){
					def e = true
					while(e){
						x0 = getRandom(ASize)
						y0 = getRandom(ASize)
						direction = getRandom(2)//0 horizontal, 1 vertical
						e = false
						for(def k=0; k<j; k++){
							if(direction==0){
								x1 = x0+k
								y1 = y0
							}else{
								x1 = x0
								y1 = y0+k
							}
							if(x1>=ASize||y1>=ASize){
								e = true
								break
							}
							else if((EnemyShots[x1][y1]!=0&&MyShips[x1][y1]==0)||
								TestGrid[x1][y1]!=0){
								e = true
								break
							}
						}
					}
					for(def k=0; k<j; k++){
						if(direction==0){
							TestGrid[x0+k][y0] = 1
						}else{
							TestGrid[x0][y0+k] = 1
						}
					}
				}
			}
			for(def j=0; j<ASize; j++){//add hits
				for(def k=0; k<ASize; k++){
					if(EnemyShots[j][k]!=0&&MyShips[j][k]!=0){TestGrid[j][k] = 1}
				}
			}
			def TestTotal = 0
			for(def j=0; j<ASize; j++){//add hits
				for(def k=0; k<ASize; k++){
					TestTotal = TestTotal+TestGrid[j][k]
				}
			}
			if(TestTotal!=14){f = true}
		}
		for(def j=0; j<ASize; j++){
			for(def k=0; k<ASize; k++){
				TotalGrid[j][k] = TotalGrid[j][k]+TestGrid[j][k]
			}
		}
	}
	def hitMax = 0
	def xMax = 0
	def yMax = 0
	if(lastHit){
		if(lastHitx-1<ASize&&lastHitx-1>=0){
			if(TotalGrid[lastHitx-1][lastHity]>hitMax&&
				EnemyShots[lastHitx-1][lastHity]==0){
				hitMax = TotalGrid[lastHitx-1][lastHity]
				xMax = lastHitx-1
				yMax = lastHity
			}
		}
		if(lastHitx+1<ASize&&lastHitx+1>=0){
			if(TotalGrid[lastHitx+1][lastHity]>hitMax&&
				EnemyShots[lastHitx+1][lastHity]==0){
				hitMax = TotalGrid[lastHitx+1][lastHity]
				xMax = lastHitx+1
				yMax = lastHity
			}
		}
		if(lastHity-1<ASize&&lastHity-1>=0){
			if(TotalGrid[lastHitx][lastHity-1]>hitMax&&
				EnemyShots[lastHitx][lastHity-1]==0){
				hitMax = TotalGrid[lastHitx][lastHity-1]
				xMax = lastHitx
				yMax = lastHity-1
			}
		}
		if(lastHity+1<ASize&&lastHity+1>=0){
			if(TotalGrid[lastHitx][lastHity+1]>hitMax&&
				EnemyShots[lastHitx][lastHity+1]==0){
				hitMax = TotalGrid[lastHitx][lastHity+1]
				xMax = lastHitx
				yMax = lastHity+1
			}
		}
		if(hitMax==0){
			lastHit = false
			lastHitx = 0
			lastHity = 0
		}
	}
	if(!lastHit){
		for(def i=0; i<ASize; i++){
			for(def j=0; j<ASize; j++){
				if(TotalGrid[i][j]>hitMax&&EnemyShots[i][j]==0){
					hitMax = TotalGrid[i][j]
					xMax = i
					yMax = j
				}
			}
		}
	}
	return xString[xMax]+yString[yMax]
}

def setupEstim = {//------------------------------------------------------------------------
	setImage(B+"/Battleships002-"+(loadBoolean("intro.female")?"f":"m")+".jpg")
	show(Title+"You have to attach your estim device somewhere below the waist. "+
			"Make it somewhere sensitive!")
	showButton("done")
	if(getBoolean(Title+"Is your estim device worked by audio inputs?")) {
		setImage(B+"/Battleships004.png")
//testing
		def e = true
		while(e) {
			setImage(B+"/Battleships004.png")
			switch(getSelectedValue(Title+"You should test the level!\n\n"+
				"Don't continue until you're sure your "+
				"device is working. Test what happens when a destroyer "+
				"is hit.",["you hit", "enemy hit", "done"])){
			case 0:
				playBackgroundSound(B+"/Hit.mp3")
				wait(1.0)
				playBackgroundSound(null)
				wait(0.2)
				break
			case 1:
				playBackgroundSound(B+"/EnemyHit.mp3")
				wait(1.0)
				playBackgroundSound(null)
				wait(0.2)
				break
			case 2:
				e = false
				break
			}
		}
		return true
	}else{
		setImage(B+"/Battleships003.png")
		show(Title+"Sorry, this script only works with audio estim")
		showButton("Bye!")
		wait(1)
		setImage(null)
		show(null)
		return false
	}
}

//START========================================================================

def Play = true
while(Play){
	setImage(B+"/Battleships001.png")
	switch(getSelectedValue(Title+"This is the board game Battleships. You "+
		"get shocks from your audio estim as you play. If your ships are hit, "+
		"that could be painful, but when you hit your enemy's ship, if might "+
		"be fun.\n\nYou can adjust some parameters "+
		"under 'rules'.", ["play", "rules", "gallery", "end"])){
	case 0://play
	if(!setupEstim())return false
//clear grids
		MyShips = [[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0]]
		EnemyShips = [[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0]]
		MyShots = [[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0]]
		EnemyShots = [[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0],
			[0, 0, 0, 0, 0, 0, 0]]
		lastHit = false
		lastHitx = 0
		lastHity = 0
		MyScore = 0
		MyScores = [0, 2, 3, 4, 5]
		EnemyScore = 0
		EnemyScores = [0, 2, 3, 4, 5]
		GetEnemyShips()
		ShowGrids()
//place my ships
		for(def i=4; i>0; i--){
			SelectShip(i)
		}
		def FirstTurn = 0
		def WhoStarts = ["", "you take", "your enemy takes"]
		def c = ""
		def x = -1
		def y = -1
//main game loop
		while(MyScore<14&&EnemyScore<14){
			if(FirstTurn==1||FirstTurn==2)FirstTurn=3	
			if(FirstTurn==0){
				FirstTurn = getRandom(2)+1//1 = me, 2 = enemy
				show(Title+"We flipped a coin and "+WhoStarts[FirstTurn]+" the "+
					"first shot")
				showButton("OK")
			}
//my turn
			if(FirstTurn!=2){
				c = getString(Title+"Your shot (A1 to G7):", "")
				if(c.length()==2){
					x = xString.indexOf(c[0].toUpperCase())
					y = yString.indexOf(c[1])
				}else{
					x = -1
					y - -1
				}
				def e = true
				while(e){
					if(c.length()==2&&x>-1&&y>-1){
						if(MyShots[x][y]==0){
							e = false
							break
						}
					}
					c = getString(Title+"Try again (A1 to G7):", "")
					if(c.length()==2){
						x = xString.indexOf(c[0].toUpperCase())
						y = yString.indexOf(c[1])
					}else{
						x = -1
						y - -1
					}
				}	
				MyShots[x][y] = 1
				ShowGrids()
				if(EnemyShips[x][y]!=0){
					MyScore++
					MyScores[EnemyShips[x][y]]--
					if(MyScores[EnemyShips[x][y]]>0){
						show(Title+"Hit")
						playBackgroundSound(B+"/Hit.mp3")
						wait(1.0)
						playBackgroundSound(null)
						wait(0.2)
						showButton("OK")
					}else{
						show(Title+"You sank my "+ShipType[EnemyShips[x][y]])
						ShowGrids()
						playBackgroundSound(B+"/Hit.mp3")
						wait(ShipSize[EnemyShips[x][y]]*1.5)
						playBackgroundSound(null)
						wait(0.2)
						showButton("OK")
					}
					ShowGrids()
					if(ShowPics){
						setImage(EnemyPictures[MyScore])
						wait(2)
					}
				}else{
					show(Title+"Miss")
					showButton("OK")
					ShowGrids()
				}
			}
//enemy turn
			if(MyScore<14){
				c = GetEnemyShot()
				x = xString.indexOf(c[0].toUpperCase())
				y = yString.indexOf(c[1])
				ShowGrids()
				EnemyShots[x][y] = 1
				c = xString[x]+yString[y]
				show(Title+"Enemy shot is "+c)
				showButton("OK")
				ShowGrids()
				if(MyShips[x][y]!=0){
					EnemyScore++
					EnemyScores[MyShips[x][y]]--
					ShowGrids()
					if(EnemyScores[MyShips[x][y]]>0){
						lastHit = true
						lastHitx = x
						lastHity = y
						show(Title+"Your "+ShipType[MyShips[x][y]]+
							" has been hit.")
						playBackgroundSound(B+"/EnemyHit.mp3")
						wait(1.0)
						playBackgroundSound(null)
						wait(0.2)
						showButton("OK")
					}else{
						lastHit = false
						lastHitx = 0
						lastHity = 0
						show(Title+"Your "+ShipType[MyShips[x][y]]+
							" has been destroyed")
						playBackgroundSound(B+"/EnemyHit.mp3")
						wait(ShipSize[MyShips[x][y]]*1.5)
						playBackgroundSound(null)
						wait(0.2)
						showButton("OK")
					}
					if(TakePics){
						if(getBoolean(Title+"Do you want to take a picture?")){
							def p = getPicture()
							wait(2)
							save(B+".mypicture"+EnemyScore, p)
						}
					}
					ShowGrids()
				}else{
					show(Title+"Miss")
					showButton("OK")
				}
			}
		}
		if(MyScore==14&&EnemyScore<14){
			show(Title+"You win!")
			playBackgroundSound(B+"/Hit.mp3")
			wait(EnemyScore)
			playBackgroundSound(null)
			wait(0.2)
			showButton("OK")
		}else if(MyScore<14&&EnemyScore==14){
			show(Title+"You lose!")
			playBackgroundSound(B+"/EnemyHit.mp3")
			wait(MyScore)
			playBackgroundSound(null)
			wait(0.2)
			showButton("OK")
		}else{
			show(Title+"It's a draw!")
			showButton("OK")
		}
		break
	case 1://rules
		setImage(null)
		show(Title+"This game of Battleships is played on a small 7x7 "+
			"grid with four ships. If your enemy hits one of your ships, "+
			"you get a painful shock. If your ship is sunk, you get a longer "+
			"shock. The bigger the ship, the longer the shock. If you hit an "+
			"enemy ship, you get a fun blast of estim.<table>"+
			"<tr><td>aircraft carrier</td><td>A</td><td>5 squares</td></tr>"+
			"<tr><td>battleship</td><td>B</td><td>4 squares</td></tr>"+
			"<tr><td>cruiser</td><td>C</td><td>3 squares</td></tr>"+
			"<tr><td>destroyer</td><td>D</td><td>2 squares</td></tr>"+
			"</table>More information about how to play:\n"+
			"en.wikipedia.org/wiki/Battleship_(game)")
		showButton("OK")
		TakePics = getBoolean(Title+"Each time one of your ships is hit, you can take a picture. "+
			"These pictures are stored locally, and you can see "+
			"them by choosing 'Gallery' on the main menu. While viewing your "+
			"pictures, you may be given the option to upload a picture to the "+
			"server. If you do, any other players may see it as one of the "+
			"'enemy pictures' when they play. Taking and sending pictures to "+
			"the server is completely optional.\n\nCurrently, taking picures "+
			"is switched "+(TakePics?"on":"off")+". Please confirm your "+
			"choice.", "on", "off")
		save(B+".TakePics", TakePics)
		nTries = getInteger(Title+"You are playing against the computer. "+
			"You can adjust is the amount of processing the "+
			"computer does to calculate its next shot. Recommended values are "+
			"between 1,000 (stupid) and 10,000 (skilled). Higher values will "+
			"mean your enemy 'thinks' for longer, and the game is slower, but "+
			"values greater than about 10,000 do not increase its skill "+
			"significantly. A value less than about 1,000 means your enemy is "+
			"firing almost at random, and should be easy to beat.", nTries)
		save(B+".nTries", nTries)
		maxTime = getInteger(Title+"You can limit the time the computer spends "+
			"'thinking'. Processing time depends on the state of the "+
			"board, and with partially-sunk ships, it can be long. You can "+
			"specify a maximum time in seconds. You need to consider the speed "+
			"of your peocessor, but a value around 100s may be good.", maxTime)
		save(B+".maxTime", maxTime)
		Connected = getBoolean(Title+"You can play without connecting to the "+
			"internet. Currently you are "+(Connected?"":"not")+" connected."+
			" This only applies to this script.", "connected", "disconnected")
		save(B+".Connected", Connected)
		ShowPics = getBoolean(Title+"You see pictures that may be either of "+
			"other players or some default pictures that came with the script. "+
			"Currently this option is  "+(ShowPics?"on":"off")+"."+
			" Please confirm your choice.", "on", "off")
		save(B+".ShowPics", ShowPics)
		break
		ShowPics = getBoolean(Title+"You see pictures that may be either of "+
			"other players or some default pictures that came with the script. "+
			"Currently this option is  "+(ShowPics?"on":"off")+"."+
			" Please confirm your choice.", "on", "off")
		save(B+".ShowPics", ShowPics)
		break
	case 2://
		for(def i=1; i<15; i++){
			def p = loadString(B+".mypicture"+i)
			if(p!=null&&p!=""){
				setImage(p)
				show(Title+"Picture "+i)
				showButton("OK")
				if(Connected&&getRandom(15)==1){
					if(getBoolean(Title+"Would you like to add this picture to "+
						"those on the server? Other players may see it when they "+
						"play.")){
						show(Title+"Sending...")
						def c = sendImage(p)
						send(B+".picture"+i, c)
						showButton("OK")
					}
				}
			}
		}
		break
	case 3://quit
		setImage(null)
		show(null)
		Play = false
		wait(2)
	}
}
// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/BattleshipShock.groovy
 * images/BattleshipShock/*.jpg
 * images/BattleshipShock/*.png
 * sounds/BattleshipShock/*.mp3
 */

